<?php

/**
 * @file
 * Winbank redirect menu items.
 */

/**
 * Hook function for succesful order.
 */
function commerce_winbank_redirect_complete() {
  $order_id = $_POST['MerchantReference'];
  $order = commerce_static_checkout_url_load_order_or_die($order_id);
  if(!isset($_SESSION['koobebe']['ticket_response'])){
    commerce_static_checkout_url_redirect_with_error('winbank', $order, 'can not get values from session', TRUE);
  }

  $ticket_request = $_SESSION['koobebe']['ticket_request'];
  $ticket_response = $_SESSION['koobebe']['ticket_response'];

  $long_str = $ticket_response['trans_ticket'].$ticket_request['PosId'].$ticket_request['AcquirerId'].$ticket_request['MerchantReference'].$_POST['ApprovalCode'].$_POST['Parameters'].$_POST['ResponseCode'].$_POST['SupportReferenceID'].$_POST['AuthStatus'].$_POST['PackageNo'].$_POST['StatusFlag'];
  $hash = strtoupper(hash('sha256',$long_str));
  
  if ($_POST['ResultCode'] != 0 or !in_array($_POST['ResponseCode'],array('00','08','10',11,'16'))) {
    commerce_static_checkout_url_redirect_with_error('winbank', $order, 'Wrong POST DATA', TRUE);
  } else if ($hash != $_POST['HashKey']) {
    commerce_static_checkout_url_redirect_with_error('winbank', $order, 'hashes do not match '.$hash. ' '.$_POST['HashKey'], TRUE);
  }

  if($_POST['ResponseCode'] == '11'){
    watchdog('commerce_winbank', 'Double charge attempted. Order id: @order_id.', array('@order_id' => $order_id));
  }

  // successfull payment
  if($_POST['ResultCode']==0 && $_POST['StatusFlag'] == 'Success'){
    $transaction = commerce_payment_transaction_new('commerce_winbank', $order_id);
    //  $transaction->instance_id = $delta_pay_id;
    $transaction->amount = $order->commerce_order_total['und'][0]['amount'];;
    $transaction->payload[REQUEST_TIME] = $_POST;
    $transaction->status = COMMERCE_PAYMENT_STATUS_SUCCESS;
    //$transaction->remote_id = '';
    // $transaction->remote_status = '';
    $transaction->message = t('Payment was successful');
    $result = commerce_payment_transaction_save($transaction);

    commerce_checkout_complete($order);
    watchdog('commerce_winbank', 'Payment received for order: @order_id.', array('@order_id' => $order_id));
    commerce_static_checkout_url_redirect_with_success('winbank',$order);
  }
}

/**
 * Hook function for order with failure.
 */
function commerce_winbank_redirect_error() {
  $order_id = $_POST['MerchantReference'];
  $order = commerce_static_checkout_url_load_order_or_die($order_id);
  $transaction = commerce_payment_transaction_new('commerce_winbank', $order_id);
  //$transaction->instance_id = -1;
  $transaction->payload[REQUEST_TIME] = $_POST;
  $transaction->status = COMMERCE_PAYMENT_STATUS_FAILURE;
  //$transaction->remote_id = $delta_pay_id;
  //$transaction->remote_status = $payment_status;
  $transaction->message = $_POST['ResponseDescription'];
  $result = commerce_payment_transaction_save($transaction);

  commerce_static_checkout_url_redirect_with_error('winbank', $order, $_POST['ResponseDescription'].$_POST['ResultDescription']);
}

/**
 * Hook function for canceled order.
 */
function commerce_winbank_redirect_cancel() {
  $order_id = $_GET['order_id'];
  $order = commerce_static_checkout_url_load_order_or_die($order_id);

  commerce_static_checkout_url_redirect_with_cancel('winbank', $order);
}
